package com.ti.eps.emu;

import java.io.*;

public class TIEmulator30XPro
{
  public final static int ROM_SIZE = 65536;
  public static boolean libsok = false;
  public byte[] obj_byte_array;
  private native void CommunicatingWithC30XPro(int[] paramArrayOfInt);

  protected static boolean loadLibrary(String libname)
  {
    try
    {
      System.out.println("loading JNI " + libname + " from java.library.path " );
      System.loadLibrary(libname);
    }
    catch (UnsatisfiedLinkError err1)
    {
      try
      {
        System.err.println(err1);
        File file = new File(".", System.mapLibraryName(libname));
        System.out.println("loading JNI " + libname + " from " + file.getAbsolutePath());
        System.load(file.getAbsolutePath());
      }
      catch (UnsatisfiedLinkError err2)
      {
        System.err.println(err2);
        return false;
      }
    }
    return true;
  }

  public boolean SaveCalc()
  {
    try
    {
      File destinationFile = new File("TI-30XPro.rom");
      FileOutputStream fos = new FileOutputStream(destinationFile);
      fos.write(obj_byte_array);
      fos.close();
    }
    catch(Exception err)
    {
        System.err.println(err);
        return false;
    }
    return true;
  }

  public boolean LoadCalc()
  {
    int i = 0;
    int[] obj_code_array = new int[ROM_SIZE];
    obj_byte_array = new byte[ROM_SIZE*2];

    for (i = 0; i < ROM_SIZE; ++i)
      obj_code_array[i] = 0;

    CommunicatingWithC30XPro(obj_code_array);
    for (i = 0; i < ROM_SIZE; ++i)
    {
      obj_byte_array[2*i]=(byte)(obj_code_array[i]/256);
      obj_byte_array[2*i+1]=(byte)(obj_code_array[i]%256);
    }
    return true;
  }

  public static void main( String args[] )
  {   System.out.println("");
      System.out.println("+----------------------------+");
      System.out.println("| TI-SmartView ROM Extractor |");
      System.out.println("|       for TI-30X Pro       |");
      System.out.println("+----------------------------+");
      System.out.println("               Xavier ANDREANI");
      TIEmulator30XPro tc = new TIEmulator30XPro();
      System.out.println("");
      System.out.print("1) Checking DLL library ... ");
      if ( libsok )
      {
        System.out.println("*OK*");
        System.out.print("2) Requesting ROM data  ... ");
        tc.LoadCalc();
        System.out.println("*OK*");
        System.out.print("3) Writing ROM to file  ... ");
        if ( tc.SaveCalc() )
          System.out.println("*OK*");
      }
  }

  static {
      if ( loadLibrary("TI30XProMVEmulator") )
        libsok = true;
  }
}